Bug 6780 - cos() does not set errno on domain error
Summary: cos() does not set errno on domain error
Status: RESOLVED FIXED
Alias: None
Product: glibc
Classification: Unclassified
Component: math (show other bugs)
Version: unspecified
: P2 normal
Target Milestone: ---
Assignee: Andreas Jaeger
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-07-30 11:41 IST by Michael Kerrisk
Modified: 2014-07-04 05:47 IST (History)
1 user (show)

See Also:
Host:
Target:
Build:
Last reconfirmed:
fweimer: security-


Attachments
test program (2.71 KB, text/plain)
2008-07-31 08:36 IST, Michael Kerrisk
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Kerrisk 2008-07-30 11:41:35 IST
For a domain error, cos() does not set errno.  It should set errno to EDOM.

NOTE: the inverse trig functions do correctly set errno on error!

Background: 
On error, many glibc math functions both set errno and raise an exception
(fetestexcept(3)).  For example, the following  function all do this: acos(),
asin(), cosh(), sinh(), acosh(), asinh(), exp(), exp2(), ldexp(), log(),
log10(), log2().  However, there is much inconsistency.  Some functions raise an
exception, but don't set errno.  Some functions set errno for some errors, but
not others.  A few set errno, but don't raise an exception.  This series of bug
reports documents deviations from what I consider the ideal: all functions
should BOTH set errno AND raise an exception for all errors.

All of these reports relate to tests on glibc 2.8 (as provided by SUSE 11.0).
Comment 1 Michael Kerrisk 2008-07-31 08:36:57 IST
Created attachment 2845 [details]
test program

Sample run showing problem:
$ /tmp/mt_cos inf
errno == 0
fetestexcept() says:  FE_INVALID
cos(inf)=nan
0 FE_INVALID nan
Comment 2 Michael Kerrisk 2010-09-11 15:09:33 IST
This bug was fixed in glibc 2.10. The man page is updated for man-pages-2.37.